#include "dstring.h"

#define MAX_IOFUNCS 200
#define MAX_SYSVARS 200

#define LDDK_SEEK  (1<<0)
#define LDDK_READ  (1<<1)
#define LDDK_WRITE (1<<2)
#define LDDK_READDIR (1<<3)
#define LDDK_SELECT (1<<4)
#define LDDK_IOCTL  (1<<5)
#define LDDK_MMAP   (1<<6)
#define LDDK_OPEN   (1<<7)
#define LDDK_CLOSE  (1<<8)
#define LDDK_CORE   (1<<9)
#define LDDK_OPEN_SUB   (1<<10)
#define LDDK_PROCINFO (1<<11)
#define LDDK_SYSCTL  (1<<12)

extern int driver_methods;
extern int driver_major;
extern int driver_minor;

extern DynString *driver_objects;
extern DynString *driver_sources;


typedef struct {
  char *name;
  char *parlist;
  char *code;
  int  flags;
} ioctl_func_t;

#define SYSCTL_INT 1
#define SYSCTL_UINT 2
#define SYSCTL_STRING 3

typedef struct {
  char *name;
  int   type;
  int   mode;

  int   default_i;
  char *default_s;
  int   default_slen;  

  char *handler;
  char *strategy;
} sysctl_var_t;



