
#include <sys/file.h>
#include <sys/param.h>
#include <unistd.h>

#ifdef __linux__
#include <sys/stat.h>
#include <unistd.h>     /* for R_OK define */
#endif

#ifndef R_OK
#define R_OK 04
#endif


#define DEFAULT_PATH ".:/usr/local/lib/lddk/ddllib"


/* ABSOLUTE_FILENAME_P (fname): True if fname is an absolute filename */

#define ABSOLUTE_FILENAME_P(fname)	(fname[0] == '/')

extern char *copy_of(char *);



char *
find_file(file, library_path)
char *file;
char *library_path;
{
    register char *p;
    char name[MAXPATHLEN];
    extern char *getenv();

    if (library_path == NULL)
    	library_path = DEFAULT_PATH;
    		
    if (ABSOLUTE_FILENAME_P(file)) {
	return copy_of (file);
    }
#ifdef __linux__
    if ((file[0] == '.') && (file[1] == '/')) {
	getcwd (name, MAXPATHLEN);
	strcat (name, file+1);
	return copy_of (name);
    }
#endif

    p = library_path;
    while (*p) {
	register char *next;

	next = name;
	/* copy directory name into [name] */
	while (*p && *p != ':') *next++ = *p++;
	*next = 0;
	if (*p) p++;
	if (name[0] == '.' && name[1] == 0)
	    getcwd (name, MAXPATHLEN);
	if (name[0] == '\0' )   /* bypass the null directory */
	    continue;
	if (name[0] == '~') {
	  char tname[MAXPATHLEN];
	  register char *hp=getenv("HOME");
	  strcpy(tname, hp);
	  strcat(tname, &name[1]);
	  strcpy(name, tname);
	} 
	strcat (name, "/");
	strcat (name, file);

	if (access (name, R_OK) == 0) {
/*
#ifdef __linux__
	  struct stat stat_temp;
	  if (stat(name,&stat_temp)) continue;
	  if (S_IFREG != (S_IFMT & stat_temp.st_mode)) continue;
#endif
*/ 
	  return copy_of (name);
	 }
    }
    return NULL;
}

static char *
get_word(src_pp)
char **src_pp;
{
    char *p=*src_pp;
    register char *next=p;

    if (*p == '\0')
    	return NULL;
    while (*next && *next != ' ') 
	next++;
    if (*next)
	*src_pp = next + 1;
    else
    	*src_pp = next;
    *next = '\0';
    return p;
}    

char *
copy_of (s)
register char *s;
{
    register char *p = (char *) malloc (strlen(s)+1);

    if (!p) return 0;

    *p = 0;
    strcpy (p, s);
    return p;
}
