
#include "hash.h"

static struct hlist_entry *hashtab[MAX_HASHSIZE];

static int hash(char *s)
{
  int hashval;
  for (hashval=0; *s != '\0'; )
    hashval += *s++;
  return(hashval % MAX_HASHSIZE );
}


struct hlist_entry *hash_lookup(char *s)
{
  struct hlist_entry *np;

  for( np=hashtab[hash(s)]; np != NULL; np = np->next)
    if(strcmp(s,np->ident) == 0)
      return(np);
    return(NULL);
}


struct hlist_entry *hash_install(char *ident, char *val )
{
  struct hlist_entry *np;
  int hashval;

  if (( np = hash_lookup(ident)) == NULL ) {
    np = (struct hlist_entry *) malloc( sizeof(*np));
    if( np == NULL ) 
      return(NULL);
    if(( np->ident = strsave(ident)) == NULL )
      return(NULL);
    hashval = hash(np->ident);
    np->next = hashtab[hashval];
    hashtab[hashval] = np;
  } else 
    free (np->val);
    np->val = strsave(val);
  return np;

}


char *strsave(char *s)
{
  char *p;
  if(( p = malloc( strlen(s) +1 )) != NULL)
    strcpy(p,s);
  return(p);

}

char *hash_get(char *ident)
{
  struct hlist_entry *np;

  np = hash_lookup(ident);
  if( np != NULL )
    return(np->val);
  else
    return(NULL);

}
