#include <stdio.h>
#include <getopt.h>
#include <sys/param.h>
#include "iwrite.h"


extern char *pfile;
extern void usage();

int debug=0;

main(int argc,char **argv)
{
  int c;
   int make=0,sinp=0;
  extern int noline,errstat;
  extern char template_path[];
  extern char include_path[];
  extern char devel_path[];
  extern char CR_file[];
  extern IFILE *swigfile;

  char buf[120];
   char pathbuf[MAXPATHLEN];

  init_states();
  CR_file[0] = '\0';
  while(1){
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
               {"templates", 1, 0, 0},
               {"includes",  1, 0, 0},
	       {"help",      0, 0, 0},
	       {"noline",    0, 0, 0},
	       {"make",      0, 0, 0},
	       {"debug",     0, 0, 0},
	       {"stdin",     0, 0, 0},
	       {"cfile",     1, 0, 0},
               {0, 0, 0, 0}
             };

             c = getopt_long (argc, argv, "mlC:I:T:s",
                        long_options, &option_index);

	     switch(c){
	     case 0:
	       switch( option_index ){
	       case 0:
		 strcpy( template_path ,optarg );
		 break;
	       case 1:
		 strcat( include_path ,":" );
                 strcat( include_path , optarg );
		 /*printf("Adding include %s \n",include_path);*/
		 break;
	       case 2:
		 usage();
		 break;
	       case 3:
		 noline = 1;
		 break;
		case 4:
		  make=1;
		  break;
	       case 5:
		 debug = 1;
		 break;
	       case 6:
		 sinp = 1;
		 break;
	       case 7:
		 strcpy(CR_file,optarg);;
		 break;
	       default:
		 exit(1);
		 break;
	       }
              break;
	     case 'T':
		 strcpy( template_path ,optarg );
		 break;
	     case 'C':
		 strcpy( CR_file ,optarg );
		 break;
             case 'I':
		 strcat( include_path ,":" );
                 strcat( include_path , optarg );
	       break;
	     case 'l':
	       noline = 1;
	       break;
	      case 'm':
		make = 1;
		break;
	     case 's':
	       sinp = 1;
	       break;
             case '?':
               usage();
               break;

             default:
	       /*printf ("?? getopt returned character code 0%o ??0",c);*/
	       break;

	      }

             if (c == -1)
             break;
  }
             if (optind < argc)
             {
	       extern FILE *yyin;
               char *s; 
               while (optind < argc) {
		 s = argv[optind++];
		 if(( yyin = fopen( s ,"r" )) == NULL ){
		   printf("Can't open input %s \n",s);
		   exit(1);
		 }
                 pfile = s;  
                 init_main();
                 yyparse();
		 fclose(yyin);
	       }

             }
             else {
	       extern FILE *yyin;
	       if(sinp) {
		 yyin = stdin;
		 init_main();
		 yyparse();
		 exit(0);
	       } else {
		 usage();
		 printf("Error: No input files! \n");
		 exit(1);
	       }
	     }


  release_states();
  if(make && !errstat ){  
    printf(" Make in sourcetree: %s ...\n\n",devel_path);fflush(stdout);
     sprintf(buf,"cd %s ; make",devel_path);
     system(buf);
  }
   
  exit(0);
}


void usage(){

fprintf(stderr,"\
 DDL -> C Compiler (C)1996 Claus Schroeter (clausi@chemie.fu-berlin.de) \n\
 Usage:\n\
   ddl2c [options] ddlfile\n\
 Options:\n\
  --templates, -T     set template path\n\
  --includes,  -I     add include path\n\
  --cfile,     -C     include Copyright notice from file\n\
  --noline,    -l     generate without #line directives\n\
  --make,      -m     execute make after generating files\n\
  --stdin,     -s     read input from stdin\n\
  --help,      -?     display this message\n\
");
}
