module "Submod" : /* (of course this driver does nothing useful) */

/* 
 * Now let's define some submodules
 */

driver "Chip1" [ minor=5 ] {
	open /{
		printk("Chip1 opened");
	}/	
	close /{
		printk("Chip1 closed");
	}/
	ioctl {
		func Reset() 
                /{ 
			/* do a chip reset here */
		}/
                func Test(int port ) 
		/{
                       /* this is just a test */
		}/
                func Test2(int port , int param ) 
		/{
                      /* this is just another test */
		}/
        }
}

driver "Chip2" [ minor ] {
	open /{
		printk("Chip2 opened");
	}/	
	close /{
		printk("Chip2 closed");
	}/
}


/* 
 * the master driver now has only the core method and
 * the open-submodules method that maps the submodule
 * file_operations struct over the main fops and calls
 * the submodule->open function if accessed.
 */

driver "Main" [ major=35 ] {

/*
 * The header statement adds additional header files to the source tree
 * that are included in Test_P.h
 * (the .h will be appended implicitely)
 */

header "Register" /{

#define CMD_REG (base)
#define MODE_REG (base)+1

}/

/*
 * The file statement adds additional C-files to the source tree
 * each file has Test_P.h included automagically
 * (the .c will be appended implicitely)
 */

file "Irq_Service" /{

  int irq_handler(){
	printk("IRQ occured\n");	
  }

}/


	core {
		init /{ 
		  printk("** Test driver initialized\n");
		}/

		cleanup /{
		 printk("** Remove Test driver\n");
		}/
        }
	open-submodules
}




