/@
  This example shows how an user defined handler can be used to 'parse'
  a string to set an integer variable in the driver, in this case a simple
  'on' or 'off' will be translated to 1 or 0 respectively.
  
@/
module "Sysctl2" : 
driver "Sysctl2" [ major=34 ] {



	sysctl {

                int option [ handler=OptionHandler ] = 0

                handler OptionHandler /{ 

			int len;
                        int *val;
			char *p, c;
	                #define TMPBUFLEN 20
			char buf[TMPBUFLEN];

		        printk("Option Handler called :");

	
			if (!table->data || !table->maxlen || !*lenp ||
	    		  (filp->f_pos && !write)) {
			  *lenp = 0;
			  DBGout(); return 0;
			}
	
			val = (int *) table->data;

			if (write) {
                                printk("write");
				len = 0;
				p = buffer;
				while (len < *lenp && 
		       		(c = get_user(p++)) != 0 && c != '\n')
				len++;
			        if (len >= TMPBUFLEN)
				  len = TMPBUFLEN-1;
				memcpy_fromfs(buf, buffer, len);
				buf[len]=0;                                  
				printk("buf='%s'\n",buf);

				if( buf[0] == 'o' && !strcmp(buf,"on"))
					*val = 1;
				if( buf[0] == 't' && !strcmp(buf,"true"))
					*val = 1;
				if( buf[0] == 'o' && !strcmp(buf,"off"))
					*val = 0;
				if( buf[0] == 'o' && !strcmp(buf,"false"))
					*val = 0;

			} else {
				printk("read");

				switch(*val){
				  case 0:
					sprintf(buf,"off\n");
					break;
				  case 1:
					sprintf(buf,"on\n");
					break;
				  default:
					sprintf(buf,"unknown\n");
					break;
				}
				len = *lenp;
				if (len)
					memcpy_tofs(buffer, buf, strlen(buf));
				len = strlen(buf);
			
			        *lenp = len;
			        filp->f_pos += len;
			}
                        printk("\n");
			DBGout(); return 0;

                }/

     }

/*----- the driver cores */

	core {  
		init /{
			printk("init called\n");
		}/

		cleanup /{
			printk("cleanup called\n");
		}/
	}

	open /{
		printk("open called\n");
	}/

	close /{
		printk("close called\n");
	}/

}

