file "Rdelete" /{

/*
 * RCS_delete() removes desired entry from hash table
 *
 */

int RCS_delete( char *s ) {
  RCS_entry *np,*op;
  DBGin("RCS_delete");

  if(( np = RCS_lookup(s)) == NULL ) {
    DBGprint(DBG_DATA,("Entry %s not found!",s));
    DBGout();
    return(NULL);
  }
  if(np->callback != NULL){
	DBGprint(DBG_DATA,("Calling Callback"));
	(*np->callback)(RCS_DELETE_EVENT,np);
  }
  if(np->next != NULL) {
    op = np->next;
    op->prev = np->prev;
  }
  if(np->prev != NULL) {
    op = np->prev;
    op->next = np->next;
  }
  if(np->type == RCS_STRING && np->uval.sval != NULL)
    kfree(np->uval.sval);
  DBGprint(DBG_DATA,("free @=0x%lx",np));
  if(np->prev == NULL && np->next != NULL){
    RCS_hashtab[RCS_hash(s)] = np->next;	
  } 
  if( np->next == NULL && np->prev == NULL ){
    kfree(np); 
    RCS_hashtab[RCS_hash(s)] = NULL;
  } else
    kfree(np);

  DBGout();
}




}/