file "Rinstall" /{
/*
 * RCS_install() adds entry to the hash table
 *
 */

int umask = O_RD | O_WR | G_RD | A_RD; /* default access mode */

RCS_entry *RCS_install(char *name,RCS_entry *entry)
{
  RCS_entry *np, *RCS_lookup(char *);

  int hashval;

  DBGin("RCS_install");
  DBGprint(DBG_DATA,("name=%s",name));
  if(( np = RCS_lookup(name)) == NULL ) { /* not found */
    np = (RCS_entry *) kmalloc(sizeof(*np),GFP_KERNEL);
    if( np == NULL ) {
      DBGout();
      return(NULL);
    }
    /* save new */

    np->callback = NULL;
    np->uid = current->uid; 
    np->gid = current->gid;
    np->sem.count = 1;     /* set semaphore to mutex */
    np->sem.wait = NULL;
    np->mflags = umask; /* default flags */
    np->type = entry->type;

    if(( np->name = RCS_strsave(name)) == NULL) {
      DBGout();
      return(NULL);
    }

    if( entry->type == RCS_STRING ){
	if(( np->uval.sval = RCS_strsave(entry->uval.sval))==NULL) {
          DBGout(); return(NULL);
	}
    } else
    if(entry->type == RCS_INT ){
	np->uval.ival = entry->uval.ival;
    } else
    if(entry->type == RCS_IPTR ){
	np->uval.iptr = entry->uval.iptr;
    } else
    if(entry->type == RCS_FPTR ){
	np->uval.fptr = entry->uval.fptr;
    } else
    printk("Warning: Illegal Type %d\n",np->type);
    np->prev = NULL;
    hashval = RCS_hash(np->name);

    if( RCS_hashtab[hashval] != NULL )
      RCS_hashtab[hashval]->prev = np; /* save pointer backwards */
    np->next = RCS_hashtab[hashval]; 
    RCS_hashtab[hashval] = np;       /* put entry on first element */

  } else { /* found */
   
  if( np->type == RCS_STRING ) {
      kfree(np->uval.sval);
  }

  if( entry->type == RCS_STRING ) {
    np->type = RCS_STRING;
    if(( np->uval.sval = RCS_strsave(entry->uval.sval))==NULL) {
       DBGout(); return(NULL);
    }
  } else 
  if( entry->type == RCS_INT ) {
    np->type = RCS_INT;
    np->uval.ival = entry->uval.ival;
  } else
  if( entry->type == RCS_IPTR ) {
    np->type = RCS_IPTR;
    np->uval.iptr = entry->uval.iptr;
  } else

  if( entry->type == RCS_FPTR ) {
    np->type = RCS_FPTR;
    np->uval.fptr = entry->uval.fptr;
  } else

    printk("RCS: Illegal type %d",entry->type);
  if( np->callback != NULL ){
	DBGprint(DBG_DATA,("calling callback"));
	(*np->callback)(RCS_CHANGE_EVENT,np);
  }
  }

  return(np);
  DBGout();
}

}/