
header "Perm" /{


/* access mode flags */
#define PERM_STICKY (0x1<<3)

#define A_RD (0x1<<2)
#define A_WR (0x1<<1)
#define A_EX (0x1<<0)

#define G_RD (0x1<<6)
#define G_WR (0x1<<5)
#define G_EX (0x1<<4)

#define O_RD (0x1<<10)
#define O_WR (0x1<<9)
#define O_EX (0x1<<8)

#define GET_O(a) ((a>>8)&0xf)
#define GET_G(a) ((a>>4)&0xf)
#define GET_A(a) ((a>>0)&0xf)

#define RCS_PERM_READ    4
#define RCS_PERM_WRITE   2
#define RCS_PERM_EXEC    1


#ifdef __KERNEL__
extern RCS_CheckPerm(RCS_entry *,int);
#endif
}/

file "RCS_Perm" /{

int RCS_CheckPerm(RCS_entry *np,int op)
{
  int uid = current->uid;
  int gid = current->gid;
  int mflags = np->mflags;
  DBGin("RCS_CheckPerm");
  DBGprint(DBG_DATA,("checking permission 0x%x against 0x%x for %d/%d %d/%d",
        np->mflags,op,uid,gid,np->uid,np->gid));
	if( uid == np->uid ){  
	  if( (GET_O(np->mflags) & op) != 0 ){
             DBGout(); return 1;
          }
        } else 
	if ( gid == np->gid ){
	  if( (GET_O(np->mflags) & op) != 0 ){
             DBGout(); return 1;
          }
	} else
	if ( (np->mflags & ( A_RD | A_WR | A_EX )) != 0 ){
	  if( (GET_A(np->mflags) & op) != 0 ){
             DBGout(); return 1;
          }
	} else {
        DBGout(); return 0;
        }
  DBGout();
  return 0;
}

}/