/*
 *
 */
header "Types" /{

#define RMGR_VERSION "0.1-a8"

#define RCS_HASHSIZE 100

#ifdef __KERNEL__

#include <linux/wait.h>	

typedef struct RCS_entry_s {
 char *name;               /* ressource name */
 int  type;                /* ressource type */
 int mflags;               /* access modes */

  union {                  /* the ressource value */
   int ival;
   char *sval;
   void *pval;
   int  *iptr;
   void (* fptr)();   
  } uval;

 void (* callback)();      /* ressource event callback */
 unsigned short uid,gid;   /* owner of this ressource */
 struct RCS_entry_s *next; /* pointer to the next ressource */
 struct RCS_entry_s *prev; /* pointer to the previous ressource */
 struct semaphore sem;     /* access semaphore */

} RCS_entry;

typedef struct RCS_string_s {
  char *s;
  int len;
} RCS_string;

extern RCS_entry *RCS_hashtab[RCS_HASHSIZE];
#endif



/*
 * Ressource Types
 *
 */

#define RCS_INT     0 /* integer type */
#define RCS_STRING  1 /* string type */
#define RCS_POINTER 2 /* pointer type (used for linked ressources) */
#define RCS_IPTR    3 /* pointer to int */
#define RCS_FPTR    4 /* function type */

/*
 * Event types
 *
 */

#define RCS_CHANGE_EVENT  0 /* change event */
#define RCS_DELETE_EVENT  1 /* delete event */
#define RCS_DESTROY_EVENT 2 /* destroy ressource */


}/

