%{
#include "y.tab.h"
int yylineno=0;

extern char *strsave(char *);

%}



%x COMMENT
%x STRING

%%

^#              BEGIN(COMMENT);
<COMMENT>[^\n]* 
<COMMENT>\n   { yylineno++; BEGIN(INITIAL);}


true            { yylval.ival = 1; return T_NUMBER; }
false           { yylval.ival = 0; return T_NUMBER; }

[0-9]+          {sscanf(yytext,"%d",&yylval.ival); 
                 return T_NUMBER;}

0x[0-9a-fA-F]+  {sscanf(yytext,"0x%x",&yylval.ival); 
                 return T_NUMBER;}


[a-zA-Z][a-zA-Z_0-9-]* {yylval.sval = strsave(yytext); strcat(yylval.sval,""); 
                       return T_IDENT;}

\"              BEGIN(STRING);
<STRING>[^"]*   { yylval.sval = strsave(yytext); strcat(yylval.sval,"");return T_STRING; }
<STRING>\"      BEGIN(INITIAL);


[ \t]
[ \n ]          { yylineno++; }
.               { return yytext[0];}



%%